Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XPDIST.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XPDIST.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XPDIST.m	(revision 623)
@@ -1,91 +1,91 @@
-XPDIST	;SFISC/RSD - site tracking; 06/01/2006 ;03/05/2008
-	;;8.0;KERNEL;**66,108,185,233,350,393,486**;Jul 10, 1995;Build 5
-	; Per VHA Directive 2004-038, this routine should not be modified.
-	;Returns ""=failed, XMZ=sent
-	;D0=ien in file 9.7, XPY=national site tracking^address(optional)
-EN(D0,XPY)	;send message
-	N %,DIFROM,XPD,XPD0,XPD1,XPD2,XPDV,XPZ,X,X1,Z,Y,XPD6,XPDTRACK
-	;Get data needed
-	I '$D(^XPD(9.7,$G(D0),0)) D BMES^XPDUTL(" INSTALL file entry missing") Q ""
-	;p350 -add node 6 for the Test# and Seq#. -REM
-	S XPD0=^XPD(9.7,D0,0),XPD1=$G(^(1)),XPD2=$G(^(2)),XPD6=$G(^(6))
-	I '$P(XPD0,U,2) D BMES^XPDUTL(" No link to PACKAGE file") Q ""
-	S XPD=$P($G(^DIC(9.4,+$P(XPD0,U,2),0)),U),XPDV=$$VER^XPDUTL($P(XPD0,U))
-	I XPD="" D BMES^XPDUTL(" PACKAGE file entry missing") Q ""
-	;XPZ(1)=start, XPZ(2)=completion date/time, XPZ(3)=run time
-	S XPZ(1)=$P(XPD1,U),XPZ(2)=$P(XPD1,U,3),XPZ(3)=$$FMDIFF^XLFDT(XPZ(2),XPZ(1),3),XPZ(1)=$$FMTE^XLFDT(XPZ(1)),XPZ(2)=$$FMTE^XLFDT(XPZ(2))
-	D LOCAL
-	S XPDTRACK=$$TRACK
-	D REMEDY ;p350 -REM
-	Q $$FORUM()
-LOCAL	;Send a message to local mail group
-	N XMY,XPDTEXT,XMTEXT,XMDUZ,XMSUB,XMZ
-	K ^TMP($J)
-	S X=$$MAILGRP^XPDUTL(XPD) Q:X=""
-	S XMY(X)="" D GETENV^%ZOSV
-	;Message for users
-	S XPDTEXT(1,0)="PACKAGE INSTALL"
-	S XPDTEXT(2,0)="SITE: "_$G(^XMB("NETNAME"))
-	S XPDTEXT(3,0)="PACKAGE: "_XPD
-	S XPDTEXT(4,0)="VERSION: "_XPDV
-	S XPDTEXT(5,0)="Start time: "_XPZ(1)
-	S XPDTEXT(6,0)="Completion time: "_XPZ(2)
-	S XPDTEXT(7,0)="Environment: "_Y
-	S XPDTEXT(8,0)="Installed by: "_$P($G(^VA(200,+$P(XPD0,U,11),0)),U)
-	S XPDTEXT(9,0)="Install Name: "_$P(XPD0,U)
-	S XPDTEXT(10,0)="Distribution Date: "_$$FMTE^XLFDT($P(XPD1,U,4))
-	S XMDUZ=$S($P(XPD0,U,11):+$P(XPD0,U,11),1:.5),XMTEXT="XPDTEXT(",XMSUB=$P(XPD0,U)_" INSTALLATION"
-	D ^XMD
-	Q
-TRACK()	; Should VA track the installation of this patch at a national level?
-	Q:$G(XPY)="" 0  ; No - National site tracking was not requested
-	;Quit if not VA production primary domain
-	I $G(^XMB("NETNAME"))'[".VA.GOV" D BMES^XPDUTL(" Not a VA primary domain") Q 0
-	;X ^%ZOSF("UCI") S %=^%ZOSF("PROD")
-	;S:%'["," Y=$P(Y,",")
-	;I Y'=% D BMES^XPDUTL(" Not a production UCI") Q ""
-	; 486/GMB Replaced the above 3 lines with the following line:
-	I '$$PROD^XUPROD D BMES^XPDUTL(" Not a production UCI") Q 0
-	Q 1
-REMEDY	;Send to Remedy Server - ESSRESOURCE@MED.VA.GOV *p350 -REM
-	Q:'XPDTRACK
-	N XMY,XPDTEXT,XMTEXT,XMDUZ,XMSUB,XMZ
-	K ^TMP($J)
-	S:XPY XMY("ESSRESOURCE@MED.VA.GOV")=""
-	S:$L($P(XPY,U,2)) XMY($P(XPY,U,2))=""
-	;Message for server (all in one string)
-	;XMTEXT=Type(1),Domain(2-65),Pkg(66-95),Version(96-125),
-	;       StartTime(126-147),CompleteTime(148-169),RunTime(170-177),
-	;       Date(178-199),InstalledBy(200-229),InstallName(230-259),
-	;       DistributionDate(260-281),Seq#(282-286),
-	;       PatchTestVersion(287-317)
-	;
-	S X1=1_$G(^XMB("NETNAME")) ;Type is always "1"(1=patch,0=pkg).
-	S $E(X1,66,95)=XPD,$E(X1,96,125)=XPDV,$E(X1,126,147)=XPZ(1),$E(X1,148,169)=XPZ(2),$E(X1,170,177)=XPZ(3),$E(X1,178,199)=DT
-	S $E(X1,200,229)=$P($G(^VA(200,+$P(XPD0,U,11),0)),U),$E(X1,230,259)=$P(XPD0,U),$E(X1,260,281)=$P(XPD1,U,4),$E(X1,282,286)=$P(XPD6,U,2),$E(X1,287,317)=$P(XPD6,U)
-	S XPDTEXT(1,0)=X1
-	S XMDUZ=$S($P(XPD0,U,11):+$P(XPD0,U,11),1:.5),XMTEXT="XPDTEXT(",XMSUB="KIDS-"_$P(XPD0,U)_" INSTALLATION"
-	D ^XMD
-	Q
-FORUM()	;send to Server on FORUM
-	Q:'XPDTRACK ""
-	N XMY,XPDTEXT,XMTEXT,XMDUZ,XMSUB,XMZ
-	K ^TMP($J)
-	S:XPY XMY("S.A5CSTS@FORUM.VA.GOV")=""
-	S:$L($P(XPY,U,2)) XMY($P(XPY,U,2))=""
-	;Message for server
-	S XPDTEXT(1,0)="PACKAGE INSTALL"
-	S XPDTEXT(2,0)="SITE: "_$G(^XMB("NETNAME"))
-	S XPDTEXT(3,0)="PACKAGE: "_XPD
-	S XPDTEXT(4,0)="VERSION: "_XPDV
-	S XPDTEXT(5,0)="Start time: "_XPZ(1)
-	S XPDTEXT(6,0)="Completion time: "_XPZ(2)
-	S XPDTEXT(7,0)="Run time: "_XPZ(3)
-	S XPDTEXT(8,0)="DATE: "_DT
-	S XPDTEXT(9,0)="Installed by: "_$P($G(^VA(200,+$P(XPD0,U,11),0)),U)
-	S XPDTEXT(10,0)="Install Name: "_$P(XPD0,U)
-	S XPDTEXT(11,0)="Distribution Date: "_$P(XPD1,U,4)
-	S XPDTEXT(12,0)=XPD2
-	S XMDUZ=$S($P(XPD0,U,11):+$P(XPD0,U,11),1:.5),XMTEXT="XPDTEXT(",XMSUB=$P(XPD0,U)_" INSTALLATION"
-	D ^XMD
-	Q "#"_$G(XMZ)
+XPDIST ;SFISC/RSD - site tracking; 06/01/2006
+ ;;8.0;KERNEL;**66,108,185,233,350,393**;Jul 10, 1995;Build 12
+ ;Returns ""=failed, XMZ=sent
+ ;D0=ien in file 9.7, XPY=national site tracking^address(optional)
+EN(D0,XPY) ;send message
+ N %,DIFROM,XPD,XPD0,XPD1,XPD2,XPDV,XPDTEXT,XPZ,XMDUZ,XMSUB,XMTEXT,XMY,XMZ,X,X1,Z,Y,XPD6
+ ;Get data needed
+ I '$D(^XPD(9.7,$G(D0),0)) D BMES^XPDUTL(" INSTALL file entry missing") Q ""
+ ;p350 -add node 6 for the Test# and Seq#. -REM
+ S XPD0=^XPD(9.7,D0,0),XPD1=$G(^(1)),XPD2=$G(^(2)),XPD6=$G(^(6))
+ I '$P(XPD0,U,2) D BMES^XPDUTL(" No link to PACKAGE file") Q ""
+ S XPD=$P($G(^DIC(9.4,+$P(XPD0,U,2),0)),U),XPDV=$$VER^XPDUTL($P(XPD0,U))
+ I XPD="" D BMES^XPDUTL(" PACKAGE file entry missing") Q ""
+ ;XPZ(1)=start, XPZ(2)=completion date/time, XPZ(3)=run time
+ S XPZ(1)=$P(XPD1,U),XPZ(2)=$P(XPD1,U,3),XPZ(3)=$$FMDIFF^XLFDT(XPZ(2),XPZ(1),3),XPZ(1)=$$FMTE^XLFDT(XPZ(1)),XPZ(2)=$$FMTE^XLFDT(XPZ(2))
+ D LOCAL
+ D REMEDY ;p350 -REM
+ Q $$FORUM()
+ ;
+ ;
+FORUM() ;send to Server on FORUM
+ K XMY,XPDTEXT ;393
+ Q:$G(XPY)="" ""
+ S:XPY XMY("S.A5CSTS@FORUM.VA.GOV")="" ;,XMY("ESSRESOURCE@MED.VA.GOV")=""
+ S:$L($P(XPY,U,2)) XMY($P(XPY,U,2))=""
+ K ^TMP($J)
+ ;Quit if not VA production primary domain
+ I $G(^XMB("NETNAME"))'[".VA.GOV" D BMES^XPDUTL(" Not a VA primary domain") Q ""
+ X ^%ZOSF("UCI") S %=^%ZOSF("PROD")
+ S:%'["," Y=$P(Y,",")
+ I Y'=% D BMES^XPDUTL(" Not a production UCI") Q ""
+ ;Message for server
+ S XPDTEXT(1,0)="PACKAGE INSTALL"
+ S XPDTEXT(2,0)="SITE: "_$G(^XMB("NETNAME"))
+ S XPDTEXT(3,0)="PACKAGE: "_XPD
+ S XPDTEXT(4,0)="VERSION: "_XPDV
+ S XPDTEXT(5,0)="Start time: "_XPZ(1)
+ S XPDTEXT(6,0)="Completion time: "_XPZ(2)
+ S XPDTEXT(7,0)="Run time: "_XPZ(3)
+ S XPDTEXT(8,0)="DATE: "_DT
+ S XPDTEXT(9,0)="Installed by: "_$P($G(^VA(200,+$P(XPD0,U,11),0)),U)
+ S XPDTEXT(10,0)="Install Name: "_$P(XPD0,U)
+ S XPDTEXT(11,0)="Distribution Date: "_$P(XPD1,U,4)
+ S XPDTEXT(12,0)=XPD2
+ S XMDUZ=$S($P(XPD0,U,11):+$P(XPD0,U,11),1:.5),XMTEXT="XPDTEXT(",XMSUB=$P(XPD0,U)_" INSTALLATION"
+ D ^XMD
+ Q "#"_$G(XMZ)
+ ;
+LOCAL ;Send a message to local mail group
+ K ^TMP($J),XMY,XPDTEXT,XMTEXT
+ S X=$$MAILGRP^XPDUTL(XPD) Q:X=""
+ S XMY(X)="" D GETENV^%ZOSV
+ ;Message for users
+ S XPDTEXT(1,0)="PACKAGE INSTALL"
+ S XPDTEXT(2,0)="SITE: "_$G(^XMB("NETNAME"))
+ S XPDTEXT(3,0)="PACKAGE: "_XPD
+ S XPDTEXT(4,0)="VERSION: "_XPDV
+ S XPDTEXT(5,0)="Start time: "_XPZ(1)
+ S XPDTEXT(6,0)="Completion time: "_XPZ(2)
+ S XPDTEXT(7,0)="Environment: "_Y
+ S XPDTEXT(8,0)="Installed by: "_$P($G(^VA(200,+$P(XPD0,U,11),0)),U)
+ S XPDTEXT(9,0)="Install Name: "_$P(XPD0,U)
+ S XPDTEXT(10,0)="Distribution Date: "_$$FMTE^XLFDT($P(XPD1,U,4))
+ S XMDUZ=$S($P(XPD0,U,11):+$P(XPD0,U,11),1:.5),XMTEXT="XPDTEXT(",XMSUB=$P(XPD0,U)_" INSTALLATION"
+ D ^XMD
+ Q
+ ;
+REMEDY ;Send to Remedy Server - ESSRESOURCE@MED.VA.GOV *p350 -REM
+ K ^TMP($J),XMY,XPDTEXT,XMTEXT ;393
+ Q:$G(XPY)=""
+ S:XPY XMY("ESSRESOURCE@MED.VA.GOV")=""
+ S:$L($P(XPY,U,2)) XMY($P(XPY,U,2))=""
+ ;Quit if not VA production primary domain
+ I $G(^XMB("NETNAME"))'[".VA.GOV" D BMES^XPDUTL(" Not a VA primary domain") Q
+ X ^%ZOSF("UCI") S %=^%ZOSF("PROD")
+ S:%'["," Y=$P(Y,",")
+ I Y'=% D BMES^XPDUTL(" Not a production UCI") Q
+ ;Message for server (all in one string)
+ ;XMTEXT=Type(1),Domain(2-65),Pkg(66-95),Version(96-125),
+ ;       StartTime(126-147),CompleteTime(148-169),RunTime(170-177),
+ ;       Date(178-199),InstalledBy(200-229),InstallName(230-259),
+ ;       DistributionDate(260-281),Seq#(282-286),
+ ;       PatchTestVersion(287-317)
+ ;
+ S X1=1_$G(^XMB("NETNAME")) ;Type is always "1"(1=patch,0=pkg).
+ S $E(X1,66,95)=XPD,$E(X1,96,125)=XPDV,$E(X1,126,147)=XPZ(1),$E(X1,148,169)=XPZ(2),$E(X1,170,177)=XPZ(3),$E(X1,178,199)=DT
+ S $E(X1,200,229)=$P($G(^VA(200,+$P(XPD0,U,11),0)),U),$E(X1,230,259)=$P(XPD0,U),$E(X1,260,281)=$P(XPD1,U,4),$E(X1,282,286)=$P(XPD6,U,2),$E(X1,287,317)=$P(XPD6,U)
+ S XPDTEXT(1,0)=X1
+ S XMDUZ=$S($P(XPD0,U,11):+$P(XPD0,U,11),1:.5),XMTEXT="XPDTEXT(",XMSUB="KIDS-"_$P(XPD0,U)_" INSTALLATION"
+ D ^XMD
+ Q
Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XPDTA.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XPDTA.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XPDTA.m	(revision 623)
@@ -1,147 +1,135 @@
-XPDTA	;SFISC/RSD - Build Actions for Kernel Files ;02/14/2006
-	;;8.0;KERNEL;**15,44,58,131,229,393,498**;Jul 10, 1995;Build 13
-	;Per VHA Directive 2004-038, this routine should not be modified.
-	Q
-	;^XTMP("XPDT",XPDA,"KRN",FILE,DA) is the global root
-	;DA=ien in ^XTMP,XPDNM=package name, XPDA=package ien in ^XPD(9.6,
-OPT	;options
-	N %,%1,%2
-	;if link, kill everything and just process the menu items
-	I XPDFL=2 D  G OPTT
-	.S %=0 F  S %=$O(^XTMP("XPDT",XPDA,"KRN",19,DA,%)) Q:'%  K:%'=10 ^(%)
-	;resolve Package (0;12), remove Creator (0;5)
-	S %=^XTMP("XPDT",XPDA,"KRN",19,DA,0),$P(%,U,12)=$$PT("^DIC(9.4)",$P(%,U,12)),$P(%,U,5)=""
-	;resolve Help Frame (0;7), kill Permitted Devices (3.96;0) & queue node (200)
-	S $P(%,U,7)=$$PT("^DIC(9.2)",$P(%,U,7)),^XTMP("XPDT",XPDA,"KRN",19,DA,0)=% K ^(3.96),^(200)
-	;resolve Server Bulletin (220;1), Server Mailgroup (220;3)
-	I $D(^XTMP("XPDT",XPDA,"KRN",19,DA,220)) S %=^(220),$P(%,U)=$$PT("^XMB(3.6)",+%),$P(%,U,3)=$$PT("^XMB(3.8)",$P(%,U,3)),^XTMP("XPDT",XPDA,"KRN",19,DA,220)=%
-	;resolve RPC (RPC;0), must be type Broker
-	I $D(^XTMP("XPDT",XPDA,"KRN",19,DA,"RPC")) K:$P(^(0),U,4)'="B" ^("RPC") D
-	.;kill  "B"=name x-ref, it will be re-indexed when installed
-	.K ^XTMP("XPDT",XPDA,"KRN",19,DA,"RPC","B")
-	.;loop thru RPCs and resolve (RPC;1)
-	.S %=0 F  S %=$O(^XTMP("XPDT",XPDA,"KRN",19,DA,"RPC",%)) Q:'%  S %1=$G(^(%,0)) D
-	..S %2=$$PT("^XWB(8994)",+%1)
-	..;if can't resolve then delete
-	..I %2="" K ^XTMP("XPDT",XPDA,"KRN",19,DA,"RPC",%,0) Q
-	..;save the RPC name
-	..S $P(^XTMP("XPDT",XPDA,"KRN",19,DA,"RPC",%,0),U)=%2
-	.Q
-OPTT	;Menus can only exist for options of type: menu,protocol,protocol menu,
-	;extended action, limited, window suite
-	I "LMOQXZ"'[$P(^XTMP("XPDT",XPDA,"KRN",19,DA,0),U,4) K ^(10) Q
-	;kill  "B"=name, "C"=synonyms x-ref, it will be re-indexed when installed
-	K ^XTMP("XPDT",XPDA,"KRN",19,DA,10,"B"),^("C")
-	;loop thru 10=Menus and resolve Menu (10;1), kill if it doesn't resolve
-	S %=0 F  S %=$O(^XTMP("XPDT",XPDA,"KRN",19,DA,10,%)) Q:'%  S %1=$G(^(%,0)) D
-	.S %2=$$PT("^DIC(19)",+%1)
-	.;items must be sent by themselves, check "B" x-ref
-	.I $L(%2),$D(^XPD(9.6,XPDA,"KRN",19,"NM","B",%2)) S ^XTMP("XPDT",XPDA,"KRN",19,DA,10,%,U)=%2 Q
-	.;if I couldn't resolve this option, then kill it
-	.K ^XTMP("XPDT",XPDA,"KRN",19,DA,10,%)
-	Q
-	;
-PRO	;protocols
-	N %,%1,%2
-	;if link, kill everything and just process the menu items
-	I XPDFL=2 D  G PROT
-	.S %=0 F  S %=$O(^XTMP("XPDT",XPDA,"KRN",101,DA,%)) Q:'%  K:%'=10 ^(%)
-	;resolve Package (0;12), remove Creator (0;5)
-	S %=^XTMP("XPDT",XPDA,"KRN",101,DA,0),$P(%,U,12)=$$PT("^DIC(9.4)",$P(%,U,12)),$P(%,U,5)=""
-	;kill under Menus (10), "B"=name, "C"=synonyms
-	S ^XTMP("XPDT",XPDA,"KRN",101,DA,0)=%
-	;resolve File Link (5;1), its a variable pointer
-	S %=$P($G(^XTMP("XPDT",XPDA,"KRN",101,DA,5)),U),%1=$P(%,";",2)
-	I %,$D(@("^"_%1_+%_",0)")) S $P(^XTMP("XPDT",XPDA,"KRN",101,DA,5),U)=$P(^(0),U)_";"_%1
-	;resolve HL7 fields, node 770
-	S %=$G(^XTMP("XPDT",XPDA,"KRN",101,DA,770)) I $L(%) D  S ^XTMP("XPDT",XPDA,"KRN",101,DA,770)=%
-	.S $P(%,U)=$$PT("^HL(771)",$P(%,U)),$P(%,U,2)=$$PT("^HL(771)",$P(%,U,2))
-	.S $P(%,U,3)=$$PT("^HL(771.2)",$P(%,U,3)),$P(%,U,11)=$$PT("^HL(771.2)",$P(%,U,11))
-	.S $P(%,U,4)=$$PT("^HL(779.001)",$P(%,U,4)),$P(%,U,7)=$$PT("^HLCS(870)",$P(%,U,7))
-	.S $P(%,U,8)=$$PT("^HL(779.003)",$P(%,U,8)),$P(%,U,9)=$$PT("^HL(779.003)",$P(%,U,9))
-	.S $P(%,U,10)=$$PT("^HL(771.5)",$P(%,U,10))
-PROT	;loop thru 10=Menus and resolve Menu (10;1), kill if it doesn't resolve
-	;kill under Menus (10), "B"=name, "C"=synonyms
-	I $D(^XTMP("XPDT",XPDA,"KRN",101,DA,10,0)) K ^("B"),^("C")
-	S %=0 F  S %=$O(^XTMP("XPDT",XPDA,"KRN",101,DA,10,%)) Q:'%  S %1=$G(^(%,0)) D
-	.;%2=.01 of Menu(protocol)
-	.S %2=$$PT("^ORD(101)",+%1)
-	.;Menu must also be sent by itself, check "B" x-ref
-	.I $L(%2),$D(^XPD(9.6,XPDA,"KRN",101,"NM","B",%2)) S ^XTMP("XPDT",XPDA,"KRN",101,DA,10,%,U)=%2,$P(^XTMP("XPDT",XPDA,"KRN",101,DA,10,%,0),U,4)=$$PT("^ORD(101)",$P(%1,U,4)) Q
-	.K ^XTMP("XPDT",XPDA,"KRN",101,DA,10,%)
-	;If type is Event Driver and sending Subscribers (775)
-	I $P(^XTMP("XPDT",XPDA,"KRN",101,DA,0),U,4)="E" D
-	. ;kill Menu multiple and Subscriber x-ref "B"=name
-	. K ^XTMP("XPDT",XPDA,"KRN",101,DA,10),^(775,"B")
-	. ;loop thru 775=Subscribers and resolve pointer (775;1)
-	. S %=0 F  S %=$O(^XTMP("XPDT",XPDA,"KRN",101,DA,775,%)) Q:'%  S %1=$G(^(%,0)) D
-	.. ;%2=.01 of subscriber(protocol)
-	.. S %2=$$PT("^ORD(101)",+%1)
-	.. ;protocol must also be sent by itself, check "B" x-ref
-	.. I $L(%2),$D(^XPD(9.6,XPDA,"KRN",101,"NM","B",%2)) S ^XTMP("XPDT",XPDA,"KRN",101,DA,775,%,U)=%2 Q
-	.. K ^XTMP("XPDT",XPDA,"KRN",101,DA,775,%)
-	;quit if no Access multiple
-	Q:'$D(^XTMP("XPDT",XPDA,"KRN",101,DA,3,0))  K ^("B")
-	;loop thru Access and resolve (3;1), kill if it doesn't resolve
-	S %=0 F  S %=$O(^XTMP("XPDT",XPDA,"KRN",101,DA,3,%)) Q:'%  S %1=$G(^(%,0)) D
-	.;%2=.01 of Menu(protocol)
-	.S %2=$$PT("^DIC(19.1)",+%1)
-	.I $L(%2) S ^XTMP("XPDT",XPDA,"KRN",101,DA,3,%,0)=%2 Q
-	.K ^XTMP("XPDT",XPDA,"KRN",101,DA,3,%)
-	Q
-	;
-RTNE	;routine entry build action
-	N %,X,XPD
-	;move routine to ^XTMP("XPDT",DPK1,"RTN",routine name
-	;routines will have the checksum in XTMP("XPDT",XPDA,"RTN",X) & in
-	;Build file
-	S X=$P(^XTMP("XPDT",XPDA,"KRN",9.8,DA,0),U),XPD=^(-1)
-	Q:X=""  S %=$$LOAD(X,XPD),$P(^XPD(9.6,XPDA,"KRN",9.8,"NM",+$P(XPD,U,2),0),U,4)=%
-	K ^XTMP("XPDT",XPDA,"KRN",9.8,DA)
-	Q
-	;
-RTNF	;routine file build action
-	N X,Y,% S Y=0
-	;the routines that are left in XTMP("XPDT",XPDA,"KRN",9.8) are to be
-	;deleted at site, move name field to RTN node
-	F  S Y=$O(^XTMP("XPDT",XPDA,"KRN",9.8,Y)) Q:'Y  S %=^(Y,-1),X=^(0) D
-	.I +%=1 S ^XTMP("XPDT",XPDA,"RTN",X)=%,^("RTN")=$G(^XTMP("XPDT",XPDA,"RTN"))+1
-	;kill everything
-	K ^XTMP("XPDT",XPDA,"KRN",9.8)
-	Q
-	;
-PT(GR,DA)	;GR=file global ref, DA=ien, return .01 value
-	Q:'DA ""
-	Q:GR="" ""
-	I $D(@GR@(+DA,0))#2 Q $P(^(0),U)
-	Q ""
-	;
-GR(FN)	;returns closed global root, FN=file number
-	N Y
-	Q:'$G(FN) ""
-	S Y=$G(^DIC(FN,0,"GL")) Q:Y="" ""
-	Q $E(Y,1,($L(Y)-1))_$S($L(Y,",")>1:")",1:"")
-	;
-LOAD(X,XPD)	;load routine X, XPD=action^ien in Build file
-	;XPD = 0-load, 1-delete, 2-skip, returns checksum
-	;quit if routine is already saved
-	Q:$D(^XTMP("XPDT",XPDA,"RTN",X)) $P(^(X),U,3)
-	N DIF,XCNP,%N,%A,FDA,IEN,LN2
-	S DIF="^XTMP(""XPDT"",XPDA,""RTN"",X,",XCNP=0
-	X ^%ZOSF("LOAD")
-	S $P(^XTMP("XPDT",XPDA,"RTN",X,2,0),";",7)="Build "_(+^XPD(9.6,XPDA,6.3)),LN2=^XTMP("XPDT",XPDA,"RTN",X,2,0)
-	S IEN=$$FIND1^DIC(9.8,"","X",X)
-	;^XTMP("XPDT",XPDA,"RTN",X)=action^ien in Build^checksum
-	S %N="B"_$$SUMB^XPDRSUM($NA(^XTMP("XPDT",XPDA,"RTN",X)))
-	S $P(XPD,"^",3)=%N ;Make sure the Checksum is in the 3rd piece
-	S ^XTMP("XPDT",XPDA,"RTN",X)=XPD
-	;update count node
-	S ^("RTN")=$G(^XTMP("XPDT",XPDA,"RTN"))+1
-	N XUA,XUB S (XUA,XUB)=""
-	;Update Dev Patch field in Routine file
-	I IEN D
-	. S XUB=$P(XPDT(XPDT),U,2) S:XUB["*" $P(XUB,"*",2)=+$P(XUB,"*",2)
-	. S IEN="?+2,"_IEN_",",FDA(9.819,IEN,.01)=XUB
-	. S FDA(9.819,IEN,2)=%N,FDA(9.819,IEN,3)=$P(LN2,";",5)
-	. D UPDATE^DIE("","FDA","IEN")
-	Q %N
+XPDTA ;SFISC/RSD - Build Actions for Kernel Files ;02/14/2006
+ ;;8.0;KERNEL;**15,44,58,131,229,393**;Jul 10, 1995;Build 12
+ Q
+ ;^XTMP("XPDT",XPDA,"KRN",FILE,DA) is the global root
+ ;DA=ien in ^XTMP,XPDNM=package name, XPDA=package ien in ^XPD(9.6,
+OPT ;options
+ N %,%1,%2
+ ;if link, kill everything and just process the menu items
+ I XPDFL=2 D  G OPTT
+ .S %=0 F  S %=$O(^XTMP("XPDT",XPDA,"KRN",19,DA,%)) Q:'%  K:%'=10 ^(%)
+ ;resolve Package (0;12), remove Creator (0;5)
+ S %=^XTMP("XPDT",XPDA,"KRN",19,DA,0),$P(%,U,12)=$$PT("^DIC(9.4)",$P(%,U,12)),$P(%,U,5)=""
+ ;resolve Help Frame (0;7), kill Permitted Devices (3.96;0) & queue node (200)
+ S $P(%,U,7)=$$PT("^DIC(9.2)",$P(%,U,7)),^XTMP("XPDT",XPDA,"KRN",19,DA,0)=% K ^(3.96),^(200)
+ ;resolve Server Bulletin (220;1), Server Mailgroup (220;3)
+ I $D(^XTMP("XPDT",XPDA,"KRN",19,DA,220)) S %=^(220),$P(%,U)=$$PT("^XMB(3.6)",+%),$P(%,U,3)=$$PT("^XMB(3.8)",$P(%,U,3)),^XTMP("XPDT",XPDA,"KRN",19,DA,220)=%
+ ;resolve RPC (RPC;0), must be type Broker
+ I $D(^XTMP("XPDT",XPDA,"KRN",19,DA,"RPC")) K:$P(^(0),U,4)'="B" ^("RPC") D
+ .;kill  "B"=name x-ref, it will be re-indexed when installed
+ .K ^XTMP("XPDT",XPDA,"KRN",19,DA,"RPC","B")
+ .;loop thru RPCs and resolve (RPC;1)
+ .S %=0 F  S %=$O(^XTMP("XPDT",XPDA,"KRN",19,DA,"RPC",%)) Q:'%  S %1=$G(^(%,0)) D
+ ..S %2=$$PT("^XWB(8994)",+%1)
+ ..;if can't resolve then delete
+ ..I %2="" K ^XTMP("XPDT",XPDA,"KRN",19,DA,"RPC",%,0) Q
+ ..;save the RPC name
+ ..S $P(^XTMP("XPDT",XPDA,"KRN",19,DA,"RPC",%,0),U)=%2
+ .Q
+OPTT ;Menus can only exist for options of type: menu,protocol,protocol menu,
+ ;extended action, limited, window suite
+ I "LMOQXZ"'[$P(^XTMP("XPDT",XPDA,"KRN",19,DA,0),U,4) K ^(10) Q
+ ;kill  "B"=name, "C"=synonyms x-ref, it will be re-indexed when installed
+ K ^XTMP("XPDT",XPDA,"KRN",19,DA,10,"B"),^("C")
+ ;loop thru 10=Menus and resolve Menu (10;1), kill if it doesn't resolve
+ S %=0 F  S %=$O(^XTMP("XPDT",XPDA,"KRN",19,DA,10,%)) Q:'%  S %1=$G(^(%,0)) D
+ .S %2=$$PT("^DIC(19)",+%1)
+ .;items must be sent by themselves, check "B" x-ref
+ .I $L(%2),$D(^XPD(9.6,XPDA,"KRN",19,"NM","B",%2)) S ^XTMP("XPDT",XPDA,"KRN",19,DA,10,%,U)=%2 Q
+ .;if I couldn't resolve this option, then kill it
+ .K ^XTMP("XPDT",XPDA,"KRN",19,DA,10,%)
+ Q
+PRO ;protocols
+ N %,%1,%2
+ ;if link, kill everything and just process the menu items
+ I XPDFL=2 D  G PROT
+ .S %=0 F  S %=$O(^XTMP("XPDT",XPDA,"KRN",101,DA,%)) Q:'%  K:%'=10 ^(%)
+ ;resolve Package (0;12), remove Creator (0;5)
+ S %=^XTMP("XPDT",XPDA,"KRN",101,DA,0),$P(%,U,12)=$$PT("^DIC(9.4)",$P(%,U,12)),$P(%,U,5)=""
+ ;kill under Menus (10), "B"=name, "C"=synonyms
+ S ^XTMP("XPDT",XPDA,"KRN",101,DA,0)=%
+ ;resolve File Link (5;1), its a variable pointer
+ S %=$P($G(^XTMP("XPDT",XPDA,"KRN",101,DA,5)),U),%1=$P(%,";",2)
+ I %,$D(@("^"_%1_+%_",0)")) S $P(^XTMP("XPDT",XPDA,"KRN",101,DA,5),U)=$P(^(0),U)_";"_%1
+ ;resolve HL7 fields, node 770
+ S %=$G(^XTMP("XPDT",XPDA,"KRN",101,DA,770)) I $L(%) D  S ^XTMP("XPDT",XPDA,"KRN",101,DA,770)=%
+ .S $P(%,U)=$$PT("^HL(771)",$P(%,U)),$P(%,U,2)=$$PT("^HL(771)",$P(%,U,2))
+ .S $P(%,U,3)=$$PT("^HL(771.2)",$P(%,U,3)),$P(%,U,11)=$$PT("^HL(771.2)",$P(%,U,11))
+ .S $P(%,U,4)=$$PT("^HL(779.001)",$P(%,U,4)),$P(%,U,7)=$$PT("^HLCS(870)",$P(%,U,7))
+ .S $P(%,U,8)=$$PT("^HL(779.003)",$P(%,U,8)),$P(%,U,9)=$$PT("^HL(779.003)",$P(%,U,9))
+ .S $P(%,U,10)=$$PT("^HL(771.5)",$P(%,U,10))
+PROT ;loop thru 10=Menus and resolve Menu (10;1), kill if it doesn't resolve
+ ;kill under Menus (10), "B"=name, "C"=synonyms
+ I $D(^XTMP("XPDT",XPDA,"KRN",101,DA,10,0)) K ^("B"),^("C")
+ S %=0 F  S %=$O(^XTMP("XPDT",XPDA,"KRN",101,DA,10,%)) Q:'%  S %1=$G(^(%,0)) D
+ .;%2=.01 of Menu(protocol)
+ .S %2=$$PT("^ORD(101)",+%1)
+ .;Menu must also be sent by itself, check "B" x-ref
+ .I $L(%2),$D(^XPD(9.6,XPDA,"KRN",101,"NM","B",%2)) S ^XTMP("XPDT",XPDA,"KRN",101,DA,10,%,U)=%2,$P(^XTMP("XPDT",XPDA,"KRN",101,DA,10,%,0),U,4)=$$PT("^ORD(101)",$P(%1,U,4)) Q
+ .K ^XTMP("XPDT",XPDA,"KRN",101,DA,10,%)
+ ;If type is Event Driver and sending Subscribers (775)
+ I $P(^XTMP("XPDT",XPDA,"KRN",101,DA,0),U,4)="E" D
+ . ;kill Menu multiple and Subscriber x-ref "B"=name
+ . K ^XTMP("XPDT",XPDA,"KRN",101,DA,10),^(775,"B")
+ . ;loop thru 775=Subscribers and resolve pointer (775;1)
+ . S %=0 F  S %=$O(^XTMP("XPDT",XPDA,"KRN",101,DA,775,%)) Q:'%  S %1=$G(^(%,0)) D
+ .. ;%2=.01 of subscriber(protocol)
+ .. S %2=$$PT("^ORD(101)",+%1)
+ .. ;protocol must also be sent by itself, check "B" x-ref
+ .. I $L(%2),$D(^XPD(9.6,XPDA,"KRN",101,"NM","B",%2)) S ^XTMP("XPDT",XPDA,"KRN",101,DA,775,%,U)=%2 Q
+ .. K ^XTMP("XPDT",XPDA,"KRN",101,DA,775,%)
+ ;quit if no Access multiple
+ Q:'$D(^XTMP("XPDT",XPDA,"KRN",101,DA,3,0))  K ^("B")
+ ;loop thru Access and resolve (3;1), kill if it doesn't resolve
+ S %=0 F  S %=$O(^XTMP("XPDT",XPDA,"KRN",101,DA,3,%)) Q:'%  S %1=$G(^(%,0)) D
+ .;%2=.01 of Menu(protocol)
+ .S %2=$$PT("^DIC(19.1)",+%1)
+ .I $L(%2) S ^XTMP("XPDT",XPDA,"KRN",101,DA,3,%,0)=%2 Q
+ .K ^XTMP("XPDT",XPDA,"KRN",101,DA,3,%)
+ Q
+RTNE ;routine entry build action
+ N %,X,XPD
+ ;move routine to ^XTMP("XPDT",DPK1,"RTN",routine name
+ ;routines will have the checksum in XTMP("XPDT",XPDA,"RTN",X) & in
+ ;Build file
+ S X=$P(^XTMP("XPDT",XPDA,"KRN",9.8,DA,0),U),XPD=^(-1)
+ Q:X=""  S %=$$LOAD(X,XPD),$P(^XPD(9.6,XPDA,"KRN",9.8,"NM",+$P(XPD,U,2),0),U,4)=%
+ K ^XTMP("XPDT",XPDA,"KRN",9.8,DA)
+ Q
+RTNF ;routine file build action
+ N X,Y,% S Y=0
+ ;the routines that are left in XTMP("XPDT",XPDA,"KRN",9.8) are to be
+ ;deleted at site, move name field to RTN node
+ F  S Y=$O(^XTMP("XPDT",XPDA,"KRN",9.8,Y)) Q:'Y  S %=^(Y,-1),X=^(0) D
+ .I +%=1 S ^XTMP("XPDT",XPDA,"RTN",X)=%,^("RTN")=$G(^XTMP("XPDT",XPDA,"RTN"))+1
+ ;kill everything
+ K ^XTMP("XPDT",XPDA,"KRN",9.8)
+ Q
+PT(GR,DA) ;GR=file global ref, DA=ien, return .01 value
+ Q:'DA ""
+ I $D(@GR@(+DA,0))#2 Q $P(^(0),U)
+ Q ""
+ ;
+LOAD(X,XPD) ;load routine X, XPD=action^ien in Build file
+ ;XPD = 0-load, 1-delete, 2-skip, returns checksum
+ ;quit if routine is already saved
+ Q:$D(^XTMP("XPDT",XPDA,"RTN",X)) $P(^(X),U,3)
+ N DIF,XCNP,%N,%A,FDA,IEN,LN2
+ S DIF="^XTMP(""XPDT"",XPDA,""RTN"",X,",XCNP=0
+ X ^%ZOSF("LOAD")
+ S $P(^XTMP("XPDT",XPDA,"RTN",X,2,0),";",7)="Build "_(+^XPD(9.6,XPDA,6.3)),LN2=^XTMP("XPDT",XPDA,"RTN",X,2,0)
+ S IEN=$$FIND1^DIC(9.8,"","X",X)
+ ;^XTMP("XPDT",XPDA,"RTN",X)=action^ien in Build^checksum
+ S %N="B"_$$SUMB^XPDRSUM($NA(^XTMP("XPDT",XPDA,"RTN",X)))
+ S $P(XPD,"^",3)=%N ;Make sure the Checksum is in the 3rd piece
+ S ^XTMP("XPDT",XPDA,"RTN",X)=XPD
+ ;update count node
+ S ^("RTN")=$G(^XTMP("XPDT",XPDA,"RTN"))+1
+ N XUA,XUB S (XUA,XUB)=""
+ ;Update Dev Patch field in Routine file
+ I IEN D
+ . S XUB=$P(XPDT(XPDT),U,2) S:XUB["*" $P(XUB,"*",2)=+$P(XUB,"*",2)
+ . S IEN="?+2,"_IEN_",",FDA(9.819,IEN,.01)=XUB
+ . S FDA(9.819,IEN,2)=%N,FDA(9.819,IEN,3)=$P(LN2,";",5)
+ . D UPDATE^DIE("","FDA","IEN")
+ Q %N
Index: WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XPDTA2.m
===================================================================
--- WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XPDTA2.m	(revision 613)
+++ WorldVistAEHR/trunk/r/KERNEL-XU-A4A7-USC-XG-XLF-XNOA-XPD-XQ-XVIR-ZI-ZOSF-ZOSV-ZT-ZU-%Z-XIP--XQAB--XUC--XUR--ZIN--ZTED/XPDTA2.m	(revision 623)
@@ -1,52 +1,48 @@
-XPDTA2	;SFISC/RWF -  Build Actions for Kernel Files Cont. ;08/09/2001  12:36
-	;;8.0;KERNEL;**201,498**;Jul 10, 1995;Build 13
-	;Per VHA Directive 2004-038, this routine should not be modified.
-	Q
-	;^XTMP("XPDT",XPDA,"KRN",XPDFILE,DA) is the global root
-	;DA=ien in ^XTMP,XPDNM=package name, XPDA=package ien in ^XPD(9.6,
-	;
-PAR1E1	;PARAMETER file 8989.51: entry post
-	N XP,XP1,XP2,XP3,XP4,VP,PN,PT,ROOT
-	S ROOT=$NA(^XTMP("XPDT",XPDA,"KRN"))
-	D PAR51(DA) ;Handle the entry from 8989.51
-	S PT=$S($E($G(^XTV(8989.51,DA,1)))="P":$P(^(1),U,2),1:"") ;Data Type & Value - check if pointer in for loop
-	S:PT]"" PT=$S(PT:$$GR^XPDTA(PT),1:"") ;PT=file # of pointed to file from parm def.
-	;Now find any entrys in 8989.5 to transport, because we point to them
-	S XP=0,XP3=$P(^XPD(9.6,XPDA,0),U,2),VP=XP3_";DIC(9.4,",PN=$$PT^XPDTA("^DIC(9.4)",XP3)
-	Q:'XP3  ;No package file link
-	F  S XP=$O(^XTV(8989.5,"AC",DA,VP,XP)),XP1=0 Q:'XP  D  ;Instance
-	. F  S XP1=$O(^XTV(8989.5,"AC",DA,VP,XP,XP1)) Q:'XP1  D  ;entry
-	. . M ^XTMP("XPDT",XPDA,"KRN",8989.5,XP1)=^XTV(8989.5,XP1)
-	. . S XP3=^XTV(8989.5,XP1,0),XP4=$G(^(1)) ;param def.
-	. . S $P(@ROOT@(8989.5,XP1,0),U,2)=$$PT^XPDTA("^XTV(8989.51)",$P(XP3,U,2))
-	. . I PT]"",XP4>0 S $P(@ROOT@(8989.5,XP1,1),U)=$$PT^XPDTA(PT,XP4) ;Data Type pointer - resolve
-	. . Q  ;Will redo the ENT at other end.
-	Q
-	;
-PAR51(DA)	;Fix one 8989.51 entry in transport global
-	;Called from both PAR1E1 and PAR2E1
-	N XP,XP1,XP2,XP3,VP,PN,ROOT
-	S ROOT=$NA(^XTMP("XPDT",XPDA,"KRN"))
-	;Don't bring X-ref
-	K @ROOT@(8989.51,DA,30,"B"),^("AG")
-	S XP=0
-	;Entries in the file will be maintained by Toolkit patches.
-	Q
-	;
-PAR2E1	;PARAMETER file 8989.52 entry post
-	N XP1,XP2,XP3,ROOT
-	S ROOT=$NA(^XTMP("XPDT",XPDA,"KRN"))
-	;Resolve USE INSTANCE OF
-	S XP2=$P(^XTV(8989.52,DA,0),U,4),XP3="" I XP2 S XP3=$$PT^XPDTA($NA(^XTV(8989.51)),XP2)
-	I $L(XP3) S $P(@ROOT@(8989.52,DA,0),U,4)=XP3
-	;Resolve PARAMETERS
-	S XP1=0 K ^XTMP("XPDT",XPDA,"KRN",8989.52,DA,10,"B") ;Drop X-ref
-	F  S XP1=$O(^XTV(8989.52,DA,10,XP1)),XP3="" Q:'XP1  D
-	. S XP2=$P(^XTV(8989.52,DA,10,XP1,0),U,2)
-	. I XP2 S XP3=$$PT^XPDTA($NA(^XTV(8989.51)),XP2)
-	. I '$L(XP3) K @ROOT@(8989.52,DA,10,XP1)
-	. S $P(^XTMP("XPDT",XPDA,"KRN",8989.52,DA,10,XP1,0),U,2)=XP3
-	. ;Now to move the entries this points to.
-	. I '$D(@ROOT@(8989.51,XP2)) M @ROOT@(8989.51,XP2)=^XTV(8989.51,XP2) D PAR51(XP2)
-	. Q
-	Q 
+XPDTA2 ;SFISC/RWF -  Build Actions for Kernel Files Cont. ;08/09/2001  12:36
+ ;;8.0;KERNEL;**201**;Jul 10, 1995
+ Q
+ ;^XTMP("XPDT",XPDA,"KRN",XPDFILE,DA) is the global root
+ ;DA=ien in ^XTMP,XPDNM=package name, XPDA=package ien in ^XPD(9.6,
+ ;
+PAR1E1 ;PARAMETER file 8989.51: entry post
+ N XP,XP1,XP2,XP3,VP,PN,ROOT
+ S ROOT=$NA(^XTMP("XPDT",XPDA,"KRN"))
+ D PAR51(DA) ;Handle the entry from 8989.51
+ ;Now find any entrys in 8989.5 to transport, because we point to them
+ S XP=0,XP3=$P(^XPD(9.6,XPDA,0),U,2),VP=XP3_";DIC(9.4,",PN=$$PT^XPDTA("^DIC(9.4)",XP3)
+ Q:'XP3  ;No package file link
+ F  S XP=$O(^XTV(8989.5,"AC",DA,VP,XP)),XP1=0 Q:'XP  D  ;Instance
+ . F  S XP1=$O(^XTV(8989.5,"AC",DA,VP,XP,XP1)) Q:'XP1  D  ;entry
+ . . M ^XTMP("XPDT",XPDA,"KRN",8989.5,XP1)=^XTV(8989.5,XP1)
+ . . S XP3=^XTV(8989.5,XP1,0) ;param def.
+ . . S $P(@ROOT@(8989.5,XP1,0),U,2)=$$PT^XPDTA("^XTV(8989.51)",$P(XP3,U,2))
+ . . Q  ;Will redo the ENT at other end.
+ Q
+ ;
+PAR51(DA) ;Fix one 8989.51 entry in transport global
+ ;Called from both PAR1E1 and PAR2E1
+ N XP,XP1,XP2,XP3,VP,PN,ROOT
+ S ROOT=$NA(^XTMP("XPDT",XPDA,"KRN"))
+ ;Don't bring X-ref
+ K @ROOT@(8989.51,DA,30,"B"),^("AG")
+ S XP=0
+ ;Entries in the file will be maintained by Toolkit patches.
+ Q
+ ;
+PAR2E1 ;PARAMETER file 8989.52 entry post
+ N XP1,XP2,XP3,ROOT
+ S ROOT=$NA(^XTMP("XPDT",XPDA,"KRN"))
+ ;Resolve USE INSTANCE OF
+ S XP2=$P(^XTV(8989.52,DA,0),U,4),XP3="" I XP2 S XP3=$$PT^XPDTA($NA(^XTV(8989.51)),XP2)
+ I $L(XP3) S $P(@ROOT@(8989.52,DA,0),U,4)=XP3
+ ;Resolve PARAMETERS
+ S XP1=0 K ^XTMP("XPDT",XPDA,"KRN",8989.52,DA,10,"B") ;Drop X-ref
+ F  S XP1=$O(^XTV(8989.52,DA,10,XP1)),XP3="" Q:'XP1  D
+ . S XP2=$P(^XTV(8989.52,DA,10,XP1,0),U,2)
+ . I XP2 S XP3=$$PT^XPDTA($NA(^XTV(8989.51)),XP2)
+ . I '$L(XP3) K @ROOT@(8989.52,DA,10,XP1)
+ . S $P(^XTMP("XPDT",XPDA,"KRN",8989.52,DA,10,XP1,0),U,2)=XP3
+ . ;Now to move the entries this points to.
+ . I '$D(@ROOT@(8989.51,XP2)) M @ROOT@(8989.51,XP2)=^XTV(8989.51,XP2) D PAR51(XP2)
+ . Q
+ Q
